<template>
  <AppForm class="form" :form="form" @submit="registerExecute()">
    <Message class="my-5" v-if="errorAlertMessage" severity="error">
      {{ errorAlertMessage }}
    </Message>

    <Message class="my-5" severity="warn">
      Регистрация находится в стадии разработки
    </Message>

    <!-- <PrimeFormControlFloat>
      <PrimeFormInputTextFloat
        v-model="email"
        name="email"
        rules="required"
        label="Введите E-mail"
        type="email"
        w-full
      />
    </PrimeFormControlFloat>

    <PrimeFormControlFloat>
      <PrimeFormInputTextFloat
        id="password"
        v-model="password"
        name="password"
        label="Введите пароль"
        type="password"
        rules="required|min:8|max:32"
        w-full
      />
    </PrimeFormControlFloat>

    <PrimeFormControlFloat>
      <PrimeFormInputTextFloat
        v-model="passwordConfirmation"
        name="password_confirmation"
        rules="required|confirmed_password:@password"
        label="Повторите пароль"
        type="password"
        w-full
      />
    </PrimeFormControlFloat>

    <PrimeButton
      type="submit"
      class="mt-2"
      label="Регистрация"
      wFull
      :loading="registerLoading"
    /> -->

    <div class="text-center mt-5">
      <!-- <span>Уже есть аккаунт?</span> -->
      <NuxtLink class="ml-4 w-full" to="/auth/login"> Авторизоваться </NuxtLink>
    </div>
  </AppForm>
</template>

<script lang="ts" setup>
import Message from 'primevue/message'
import { useForm } from 'vee-validate'
import { useUserStore } from '~/stores/user'

const form = useForm()
const router = useRouter()
const { register } = useUserStore()

const errorAlertMessage: Ref<string | boolean> = ref('')

const email = ref('')
const password = ref('')
const passwordConfirmation = ref('')

const {
  execute: registerExecute,
  errorValidate,
  loading: registerLoading
} = await useAsyncDataFetch(
  () => register(email.value, password.value, passwordConfirmation.value),
  {
    immediate: false,
    async beforeFetch() {
      errorAlertMessage.value = false

      const validated = await form.validate()

      return validated.valid
    },
    onResponseError(error) {
      errorAlertMessage.value = error.message

      errorValidate(error, {
        validateRules(rules) {
          form.setErrors({
            email: rules?.email,
            password: rules?.password,
            password_confirmation: rules?.password_confirmation
          })
        }
      })
    },
    onResponseSuccess(value) {
      router.push('/')
    }
  }
)

definePageMeta({
  layout: 'auth',
  middleware: ['no-auth']
})
</script>

<style lang="scss" scoped>
.form {
  &__social {
    display: flex;
    margin: 1rem 0;
    text-align: center;
    gap: 1rem;
  }
}
</style>
